------------------------------------------------------
-- LogiBLOX DECODE Module "d"
-- Created by LogiBLOX version D.24
--    on Wed Feb 21 11:24:37 2001
-- Attributes 
--    MODTYPE = DECODE
--    BUS_WIDTH = 4
--    STYLE = GATES
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY d IS
  PORT(
    SEL: IN std_logic_vector(3 DOWNTO 0);
    ENABLE: IN std_logic;
    D_OUT: OUT std_logic_vector(15 DOWNTO 0));
END d;

-- synopsys translate_off
ARCHITECTURE sim OF d IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VSEL: std_logic_vector(3 DOWNTO 0);
    VARIABLE VENABLE: std_logic;
    VARIABLE VD_OUT: std_logic_vector(15 DOWNTO 0);
    BEGIN
      VSEL := stdvec2mvl(SEL);
      VENABLE := stdbit2mvl(ENABLE);
      xb_decode(
             VSEL,
             VENABLE,
             VD_OUT);
      D_OUT <= VD_OUT;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON SEL, ENABLE, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
