module game_state (key, blockin, CLK, WE, ADDROUT, blockout) ;

input [2:0] key;
input [2:0] blockin ;
input CLK ;

output WE ;
output [9:0] ADDROUT ;
output [2:0] blockout ;

reg WE ;
reg [9:0] ADDROUT ;
reg [4:0] state ;
reg [2:0] blockout ;
reg [2:0] key ;

always @(posedge CLK) begin

	
	
	case (state) 
		0: begin
			ADDROUT <=  33;	
			blockout <= 3 ;
			state <= 1 ;		
			WE <= 1 ;   
		end

		1: begin
			if (key == 1 || key == 2 || key == 3 || key == 4) begin
				
				case (key)
				1: begin // UP
					state <= 2 ; 
					ADDROUT <= ADDROUT - 32 ;
				end
				2: begin // LEFT
					state <= 5 ; 
					ADDROUT <= ADDROUT - 1 ;
				end
				3: begin // DOWN
					state <= 8 ;
					ADDROUT <= ADDROUT + 32 ;
				end
				4: begin // RIGHT
					state <= 11 ;
					ADDROUT <= ADDROUT + 1 ;
				end
				
				default: begin
					state <= 1;
					ADDROUT <= ADDROUT ;
				end
				endcase
				
			end
			
			else begin
				ADDROUT <= ADDROUT ;
				blockout <= 0 ;
				state <= 1 ;
				WE <= 0 ;
			end
		end	
		
		
		
		// UP
		2: begin
			if (blockin == 'b111) begin
				ADDROUT <= ADDROUT + 32;
				blockout <= 3;
				state <= 1 ;
				WE <= 0;
			end
			else begin
				ADDROUT <= ADDROUT ;
				blockout <= 3;
				state <= 3;
				WE <= 1;
			end
		end
		3: begin
			ADDROUT <= ADDROUT + 32 ;
			blockout <= 0 ;
			state <= 4 ;
			WE <= 1 ;
		end
		4: begin
			ADDROUT <= ADDROUT - 32 ;
			blockout <= 3;
			state <= 1 ;
			WE <= 0;
		end
		
		// LEFT		
		5: begin
			if (blockin == 'b111) begin
				ADDROUT <= ADDROUT + 1;
				blockout <= 3;
				state <= 1 ;
				WE <= 0;
			end
			else begin
				ADDROUT <= ADDROUT ;
				blockout <= 3;
				state <= 6;
				WE <= 1;
			end
		end
		6: begin
			ADDROUT <= ADDROUT + 1 ;
			blockout <= 0 ;
			state <= 7 ;
			WE <= 1 ;
		end
		7: begin
			ADDROUT <= ADDROUT - 1 ;
			blockout <= 3;
			state <= 1 ;
			WE <= 0;
		end
			
		// DOWN
		8: begin
			if (blockin == 'b111) begin
				ADDROUT <= ADDROUT - 32;
				blockout <= 3;
				state <= 1 ;
				WE <= 0;
			end
			else begin
				ADDROUT <= ADDROUT ;
				blockout <= 3;
				state <= 9;
				WE <= 1;
			end
		end
		9: begin
			ADDROUT <= ADDROUT - 32 ;
			blockout <= 0 ;
			state <= 10 ;
			WE <= 1 ;
		end
		10: begin
			ADDROUT <= ADDROUT + 32 ;
			blockout <= 3;
			state <= 1 ;
			WE <= 0;
		end
			
		// RIGHT		
		11: begin
			if (blockin == 'b111) begin
				ADDROUT <= ADDROUT - 1;
				blockout <= 3;
				state <= 1 ;
				WE <= 0;
			end
			else begin
				ADDROUT <= ADDROUT ;
				blockout <= 3;
				state <= 12;
				WE <= 1;
			end
		end
		12: begin
			ADDROUT <= ADDROUT - 1 ;
			blockout <= 0 ;
			state <= 13 ;
			WE <= 1 ;
		end
		13: begin
			ADDROUT <= ADDROUT + 1 ;
			blockout <= 3;
			state <= 1 ;
			WE <= 0;
		end
				
		// BLAH		
		default: begin
			ADDROUT <= ADDROUT ;
			blockout <= 0 ;
			state <= 1 ;
			WE <= 0 ;
		end

	endcase
end	

endmodule 
