module translator(CLK, NK, scancode, NI, instr);

input CLK;
input NK;
input [7:0] scancode;
output NI;
output [15:0] instr;

reg NI;
reg [15:0] instr;

reg [1:0] count;
reg [15:0] temp;

always @ (posedge CLK) begin
  
  if( NK ) begin
  
	  case (scancode)
	  	
	    8'h5A: begin // start to push the number
	      if (count == 1) begin
	        instr[4:0] <= temp[11:8];
	        instr[11:5] <= 0;
	      end
	      else if (count == 2) begin
	        instr[7:0] <= temp[11:5];
	        instr[11:8] <= 0;
	      end
	      else if (count == 3) begin
	        instr <= temp;
	      end
	      
	      // do the opcode
	      instr[15:12] <= 4'hF;
	      NI <= 1;
	      count <= 0;
	    end
	    
	    // Copy the number to the temp
	    8'h70, 8'h69, 8'h72, 8'h7A, 8'h6B, 8'h73, 8'h74, 8'h6C, 8'h75, 8'h7D,
	    8'h45, 8'h16, 8'h1E, 8'h26, 8'h25, 8'h2E, 8'h36, 8'h3D, 8'h3E, 8'h46:  begin
	      // copy the data and assert the NI when we got all 3 input numbers
	      if (count == 0) begin
	        temp[11:8] <= scancode;
	        count <= 1;
	      end
	      else if (count == 1) begin
	        temp[8:5] <= scancode;
	        count <= 2;
	      end
	      else if (count == 2) begin
	        temp[4:0] <= scancode;
	        count <= 3;
	      end
	      // update the count
	      //if(count < 2) begin
	      //  count <= count + 1;
	      //end
	      else begin
	        count <= 3;
	      end
	    end
	    
	    8'h79:  begin // add 
	      instr[15:12] <= 4'h8;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end
	    
	    8'h7B:  begin // subtract
	      instr[15:12] <= 4'h9;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end
	    
	    8'h7C:  begin // multiply
	      instr[15:12] <= 4'hA;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end 
	    
	  endcase
   end
   
   if(~NK) begin
     NI <=0;
   end     
     	  
end

endmodule     
  
			

