module Key_Sync (CLK, INPUT, OUT, KEYIN) ;

input CLK, INPUT;
input [7:0] KEYIN ;
output [2:0] OUT;

reg [2:0] OUT ;
reg [1:0] state ;

always @(posedge CLK) begin

	case (state) 
	
		0: begin
			if (INPUT) begin
				case (KEYIN) 
				'h75: begin OUT <= 1 ; state <= 1 ; end
				'h6b: begin OUT <= 2 ; state <= 1 ; end
				'h72: begin OUT <= 3 ; state <= 1 ; end
				'h74: begin OUT <= 4 ; state <= 1 ; end
				default: begin OUT <= 0; state <= 0 ; end
				endcase
			end
			else begin
				OUT <= 0;
				state <= 0 ;
			end
		end
			
		1: begin	
			if (!INPUT) begin
				OUT <= 0 ;
				state <= 2 ;
			end
			else begin
				OUT <= 0 ;
				state <= 1 ;
			end	
		end
		
		2: begin 
			if (INPUT) begin
				OUT <= 0 ;
				state <= 2 ;
			end	
			else begin
				OUT <= 0 ;
				state <= 3 ;
			end
		end
		
		3: begin
			if (INPUT) begin
				OUT <= 0;
				state <= 3 ;
			end
			else begin
				OUT <= 0;
				state <= 0;
			end
		end				
	endcase
end


endmodule 
