module rgbcalc(clk, score, lives, x, y, ballx, bally, bricks, paddlex, r, g, b);

input [12:0] score;
input [1:0] lives;
input clk;
input [9:0] x, y;
input [9:0] ballx;
input [8:0] bally;
input [59:0] bricks;
input [9:0] paddlex;
output r, g, b;

wire inpaddle, inball, inlives, inscoreOn, inscoreOff;
wire rb,ra,gb,ga,bb,ba;
wire r, g, b;
wire [6:0] bnum;
wire [5:0] bricknum;
wire bvalid;
wire [3:0] scorePos;

assign scorePos = x[6:3];
assign inscoreOn = (y < 5 && x[9] && ~x[8] && ~x[7] && x[6:3] < 13 && score[scorePos]);
assign inscoreOff = (y < 5 && x[9] && ~x[8] && ~x[7] && x[6:3] < 13 && ~score[x[6:3]]);
assign inlives = (y < 5 && ((x >= 5 && x <= 8 && lives != 0) || (x >= 10 && x <= 13 && lives > 1) || (x >= 15 && x <= 18 && lives == 3))) ? 1 : 0;
assign inpaddle = (y >= 460 && y <= 465 && x >= paddlex - 30 && x <= paddlex + 30);
assign inball = (x >= ballx - 2 && x <= ballx + 2 && y >= bally - 2 && y <= bally + 2); 
assign bnum = 10 * y[8:5] + x[9:6] - 29;
assign bricknum = (bnum > 60 || bnum == 0) ? 0 : bnum;
assign bvalid = (bricknum == 0) ? 0 : bricks[bricknum-1];

assign rb = (bvalid && ((bricknum >= 1 && bricknum <= 20) || (bricknum >= 51 && bricknum <= 60))) ? 1 : 0;
assign ra = (inpaddle | inscoreOn) ? 1 : rb;
assign r = (inball) ? 1 : ra;

assign gb = (bvalid && (bricknum >= 11 && bricknum <= 40)) ? 1 : 0;
assign ga = (inpaddle | inscoreOn | inscoreOff) ? 1 : gb;
assign g = (inball) ? 0 : ga;

assign bb = (bvalid && (bricknum >= 31 && bricknum <= 60)) ? 1 : 0;
assign ba = (inpaddle | inlives) ? 1 : bb;
assign b = (inball) ? 0 : ba;

endmodule
