module TETRIS (CLK, VH, VRGB, ROUT, GOUT, BOUT) ;

input CLK ;
input VH ;
input VRGB;  // ysynch
//input LEFT;
//input RIGHT;
//input DOWN;
//input ROTATE;
output ROUT ;
output GOUT ;
output BOUT ;

// Tetris declarations
reg [127:0] ROW;

// active piece
reg [2:0] activex;  // 3-bits -- horizontal, 4-bits -- vertical
reg [3:0] activey;  // 3-bits -- horizontal, 4-bits -- vertical
reg [1:0] active2;  // 2-bits for additional piece
reg [1:0] active3;  // 2-bits for additional piece
reg [1:0] active4;  // 2-bits for additional piece
reg [3:0] state;   // 
reg [4:0] piece;     // used to simulate random piece generation

reg [9:0] Xcounter;
reg [9:0] Ycounter;
reg [6:0] box;
reg [3:0] Counter;
reg [6:0] ActiveSpot;
reg R;
reg G;
reg B;

assign ROUT = R;
assign GOUT = G;
assign BOUT = B;

 
// Welcome to Tetris
always@(posedge CLK) begin
if(!VRGB) begin
  Xcounter <= 0; 
  Ycounter <= 0;
  R <= 1;
  G <= 1;
  B <= 1;
  Counter <= Counter + 1;
  ROW[0] <= 1;
  ROW[2] <= 1;
  ROW[4] <= 1;
  ROW[6] <= 1;
  ROW[8] <= 1;
  ROW[16] <= 1;  
  ROW[32] <= 1;
  ROW[48] <= 1;
  ROW[56] <= 1;
  ROW[64] <= 1;
  ROW[80] <= 1;  
  ROW[96] <= 1;
  ROW[112] <= 1;
  ROW[120] <= 1;
  ROW[127] <= 1;
  ROW[7] <= 1;  
      
end
else
if(VH) begin
if((Xcounter < 258) || (Xcounter > 384) || (Ycounter < 112) || (Ycounter > 350))
begin
//computer next game state
	if(Counter == 15)  // move down
	ActiveSpot <= activey * activex;
	ROW[ActiveSpot] <= 0;
	ROW[ActiveSpot + 8] <= 1;
	activey <= activey + 1;
	
	
	R <= 0;  // draw green background
	G <= 1;
	B <= 0;
end
else
//if(((Xcounter > 246)&&(Xcounter < 256)))
//begin
//	R <= 1;  // draw white border/
//	G <= 1;
//	B <= 1;
//end
//else
begin
//draw 16bit 
box <= (((Ycounter - 112)>>4)*8)+(((Xcounter - 256)>>4));
	if(ROW[box])
		begin
		   R <= 1;  // draw green background
 	  	   G <= 0;
		   B <= 0;
		end
	else
		begin
		   R <= 0;  // draw green background
		   G <= 0;
		   B <= 0;
		end



end

if(Xcounter < 639) 
  begin
  Xcounter <= Xcounter + 1;
  end
else
  begin
    Xcounter <= 0;
    Ycounter <= Ycounter + 1;
  end
 

if(piece < 5)
  piece <= piece + 1;
else
  piece <= 0;  
end
end

endmodule 
